%if 0%{?rhel} <= 7
%global with_python3 0
%global with_python2 1
%else
%global with_python3 1
%global with_python2 0
%endif

%define _unitdir   /usr/lib/systemd/system

Name:           rpm-deathwatch
Version:        0.17
Release:        1%{?dist}
Summary:        Python script and systemtap module to monitor for termination signals to processes accessing the RPM database

License:        GPLv2
URL:            http://people.redhat.com/kwalker/systemtap/rpm-deathwatch.stp
Source0:        %{name}-%{version}.tar.gz
Source1:	rpm-deathwatch
Source2:	rpm-deathwatch.service

%if %{with_python2}
%if 0%{?rhel} <= 6
BuildRequires:  python-devel python-setuptools
%define python /usr/bin/python
%else
%define python /usr/bin/python2
BuildRequires:  python2-devel python2-setuptools
%endif
%endif

%if %{with_python3}
BuildRequires:  python3-devel python3-setuptools
%define python /usr/bin/python3
%endif

%description
A python process and systemtap module to monitor process termination
signals to processes accessing the RPM database and provide informatino as
to where they originate from.

This RPM has been provided by Red Hat for testing purposes only and is
NOT supported for any other use. This RPM may contain changes that are
necessary for debugging but that are not appropriate for other uses,
or that are not compatible with third-party hardware or software. This
RPM should NOT be deployed for purposes other than testing and
debugging.


%prep
%autosetup -c
mv %{name}-%{version} python2

%if %{with_python3}
cp -a python2 python3
%endif


%install
rm -rf $RPM_BUILD_ROOT
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if %{with_python3}
%define installed 1
pushd python3
%{python} setup.py install --root $RPM_BUILD_ROOT
popd
%endif

%if %{with_python2}
%define installed 1
pushd python2
%{python} setup.py install --root $RPM_BUILD_ROOT
popd
%endif

%if 0%{?installed}
%if 0%{?rhel} <= 6
mkdir -p $RPM_BUILD_ROOT/%{_initddir}/
cp %{SOURCE1} $RPM_BUILD_ROOT/%{_initddir}/
%else
mkdir -p $RPM_BUILD_ROOT/%{_unitdir}/
cp %{SOURCE2} $RPM_BUILD_ROOT/%{_unitdir}/
%endif

mkdir -p $RPM_BUILD_ROOT/var/run/
%endif


%files
%if 0%{?rhel} <= 6
%{python_sitelib}/*
%else
%if %{with_python2}
%{python2_sitelib}/*
%else
%{python3_sitelib}/*
%endif
%endif
%{_bindir}/rpm-deathwatch
%{_localstatedir}/%{name}/*
%ghost %attr(0644,root,root) /var/run/rpm-deathwatch.fifo
%ghost %attr(0644,root,root) /var/run/rpm-deathwatch.pid
%ghost %attr(0644,root,root) /var/run/rpm-deathwatch-stap.pid

%if 0%{?rhel} <= 6
%{_initddir}/*
%else
%{_unitdir}/*
%endif

%post
%if 0%{?rhel} <= 6
    if [ $1 -eq 1 ] ; then
        chkconfig --add rpm-deathwatch
    fi
%else
    if [ $1 -eq 1 ] ; then
        systemctl enable rpm-deathwatch
    fi
%endif

%preun
%if 0%{?rhel} <= 6
    if [ $1 -eq 0 ] ; then
        service %{NAME} stop rpm-deathwatch
        chkconfig --del rpm-deathwatch
    fi
%else
    if [ $1 -eq 0 ] ; then
        systemctl stop rpm-deathwatch
        systemctl disable rpm-deathwatch
    fi
%endif

%changelog
* Tue Sep 01 2020 Kyle Walker <kwalker@redhat.com> 0.17-1
- script: Fix two regressions (kwalker@redhat.com)

* Tue Sep 01 2020 Kyle Walker <kwalker@redhat.com> 0.16-1
- script: Refactor the load_module path (kwalker@redhat.com)

* Tue Jul 28 2020 Kyle Walker <kwalker@redhat.com> 0.15-1
- stap: Fix a missing closing parenthesis (kwalker@redhat.com)

* Tue Jul 21 2020 Kyle Walker <kwalker@redhat.com> 0.14-1
- script: On failure, print the stderr (kwalker@redhat.com)

* Wed Jul 08 2020 Kyle Walker <kwalker@redhat.com> 0.13-1
- stap: Fix the instance where a full path is passed to open
  (kwalker@redhat.com)

* Wed Jul 01 2020 Kyle Walker <kwalker@redhat.com> 0.12-1
- Makefile: Split endpoints out a bit (kwalker@redhat.com)
- stap: Add the history sqlite database to monitored files (kwalker@redhat.com)
- stap: Mask SIGCHLD events. (kwalker@redhat.com)

* Mon Jun 22 2020 Kyle Walker <kwalker@redhat.com> 0.11-1
- stap: Attempt to avoid issues with cmdline evaluation (kwalker@redhat.com)

* Thu Jun 18 2020 Kyle Walker <kwalker@redhat.com> 0.10-1
- script: Remove the 'version' passing from load_module() (kwalker@redhat.com)

* Thu Jun 18 2020 Kyle Walker <kwalker@redhat.com> 0.9-1
- build: Further resolve issues with the Makefiles setup (kwalker@redhat.com)
- script: Fix the non-default argument error (kwalker@redhat.com)

* Thu Jun 18 2020 Kyle Walker <kwalker@redhat.com> 0.8-1
- script: Fix an indenting issue (kwalker@redhat.com)
- build: Boost the effectiveness of the Makefiles (kwalker@redhat.com)

* Thu Jun 18 2020 Kyle Walker <kwalker@redhat.com> 0.7-1
- python3: Fix the python3 handling across the script (kwalker@redhat.com)
- script: Handle the lack of write not returning bytes on RHEL 6
  (kwalker@redhat.com)
- stap: Change the syntax for the open/openat probe definition
  (kwalker@redhat.com)

* Thu Jun 18 2020 Kyle Walker <kwalker@redhat.com> 0.6-1
- python3: Compatibility updates for Python 3 (kwalker@redhat.com)

* Wed Jun 17 2020 Kyle Walker <kwalker@redhat.com> 0.5-1
- stap: Fix the destpid argument in the kill(...) print (kwalker@redhat.com)
- stap: Fix a semantic error around the cmdline_args array (kwalker@redhat.com)

* Wed Jun 17 2020 Kyle Walker <kwalker@redhat.com> 0.4-1
- stap: Fix the print within the syscall.kill probe (kwalker@redhat.com)
- script: Fix a typo in the script (kwalker@redhat.com)
- test: Add a vagrant-based test directory named vagrant (kwalker@redhat.com)
- units: Fix the naming issue with the RHEL 6 service script
  (kwalker@redhat.com)

* Wed Jun 17 2020 Kyle Walker <kwalker@redhat.com> 0.3-1
- stap: Add a cmdline printer (kwalker@redhat.com)
- systemtap: Update to use an associative array for get_parents()
  (kwalker@redhat.com)
- stap: Fix some minor typos (kwalker@redhat.com)

* Tue Jun 16 2020 Kyle Walker <kwalker@redhat.com> 0.2-1
- new package built with tito

* Tue Jun 16 2020 Kyle Walker <kwalker@redhat.com> 0.1-1
- Built the new package, based off of termination-signal-grabber
